import java.util.*;
import java.io.*;
import java.lang.*;

class Oppgave1c{
    int [] tabell;
    int n,K;
    int[] input;
    Scanner in;
    PrintWriter out;
    public static void main(String[] args){
	new Oppgave1c(args);
    }

    public void build(){
	// i: I am allowed to use input numbers 0, 1, ..., i
	for (int i=0;i<n;i++){
	    // is it possible to make the sum j?
	    for (int j=K;j>=input[i];j--){
		// if not marked before, and possible to create by
		// subtracting input[i], mark with current index.
		if (tabell[j]==-1 && tabell[j-input[i]]!=-1)
		    tabell[j] = i;
	    }
	}
    }
    public String backtrace(){
	int sum=K;
	String result = "";
	// start at the end, and work backwards
	for (int i=n-1;i>=0;i--){
	    // if we can avoid subtracting a number (it was set in an
	    // earlier round), avoid it
	    if (sum==0 || tabell[sum]!=i){
		result = "("+input[i]+","+"0)"+result;
	    }
	    // else, subtract the number
	    else{
		result = "("+input[i]+","+"1)"+result;
		sum-=input[i];
	    }
	}
	return result;
    }

 

    // initialize and read input
    public Oppgave1c(String[] args){
	// initialize file reader/writer
	try{
	    in = new Scanner(new FileReader(args[0]));
	}
	catch(Exception e){
	    // defaults to System.in
	    in = new Scanner(System.in);
	}
	try{
	    out = new PrintWriter(new File(args[1]));
	}
	catch(Exception e){
	    out = new PrintWriter(System.out);
	}
	try{
	    // read input
	    n = in.nextInt();
	    K = in.nextInt();
	    input = new int[n];
	    for (int i=0;i<n;i++){
		input[i] = in.nextInt();
	    }
	}
	catch(Exception e){
	    System.out.println(e);
	}
	// init table
	tabell = new int[K+1]; // tabell[0] = 0;
	for (int i=1;i<K+1;i++) tabell[i] = -1;
	build();
	// search and output
	if (tabell[K]!=-1){
	    out.print("JA "+K+" ");
	    out.println(backtrace());
	}
	else{
	    out.println("NEI");
	}
	try{
	    out.close();
	    in.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}
